=== debian/changelog ===
lxd (5.0.2+git20231211.1364ae4-9+deb13u1) trixie-security; urgency=high

  * Backport fixes for the following security issues that are unfixed by
    Canonical in the stable-5.0 branch:
    - CVE-2025-54293 / GHSA-472f-vmf2-pr3h
    - CVE-2025-54287 / GHSA-w2hg-2v4p-vmh6
    - CVE-2025-54288 / GHSA-7232-97c6-j525
  * Backport fixes for the following security issues fixed by Canonical:
    - CVE-2025-54286 / GHSA-p8hw-rfjg-689h

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 02 Oct 2025 16:23:38 +0000
